package com.jiuqi.util;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class StringHelper {
  public static final char SPACE = ' ';
  
  public static final String nullStr = "";
  
  public static final String comma = ",";
  
  public static final String semicolon = ";";
  
  public static final String leftParenthesis = "(";
  
  public static final String rightParenthesis = ")";
  
  public static final String interrogation = "?";
  
  public static final String space = " ";
  
  public static final String bias = "\\";
  
  public static final String breakstr = "\b";
  
  public static final String returnstr = "\013";
  
  public static final String select = "select ";
  
  public static final String from = " from ";
  
  public static final String where = " where ";
  
  public static final String set = " set ";
  
  public static final String and = " and ";
  
  public static final String or = " or ";
  
  public static final String not = " not ";
  
  public static final String equal = "=";
  
  public static final String insert = "insert into ";
  
  public static final String update = "update ";
  
  public static final String delete = "delete from ";
  
  public static final String create = "create table ";
  
  public static final String drop = "drop table ";
  
  public static final String alter = "alter table ";
  
  public static boolean isNull(String value) {
    return !(value != null && !value.equals("") && !value.equalsIgnoreCase("null"));
  }
  
  public static boolean isBoolean(String value) {
    if (value.equalsIgnoreCase("true"))
      return true; 
    if (value.equalsIgnoreCase("yes"))
      return true; 
    if (value.equalsIgnoreCase("T") || value.equalsIgnoreCase("Y") || value.equalsIgnoreCase("1") || value.equalsIgnoreCase("01"))
      return true; 
    if (value.equalsIgnoreCase("是") || value.equalsIgnoreCase("对") || value.indexOf("是") >= 0)
      return true; 
    return false;
  }
  
  private static final String[] TRUE_VALUES = new String[] { "1", "T", "Y", "TRUE", "是", "对" };
  
  public static boolean parseBoolean(String value) {
    for (int i = 0; i < TRUE_VALUES.length; i++) {
      if (TRUE_VALUES[i].equalsIgnoreCase(value))
        return true; 
    } 
    return false;
  }
  
  public static String getTrueValue(String value) {
    if (value.equalsIgnoreCase("true") || value.equalsIgnoreCase("false"))
      return "true"; 
    if (value.equalsIgnoreCase("yes") || value.equalsIgnoreCase("no"))
      return "yes"; 
    if (value.equalsIgnoreCase("T") || value.equalsIgnoreCase("F"))
      return "T"; 
    if (value.equalsIgnoreCase("Y") || value.equalsIgnoreCase("N"))
      return "Y"; 
    if (value.equalsIgnoreCase("是") || value.equalsIgnoreCase("否"))
      return "是"; 
    if (value.equalsIgnoreCase("1") || value.equalsIgnoreCase("0"))
      return "1"; 
    if (value.equalsIgnoreCase("01") || value.equalsIgnoreCase("00"))
      return "01"; 
    return "1";
  }
  
  public static String getFalseValue(String value) {
    if (value.equalsIgnoreCase("true") || value.equalsIgnoreCase("false"))
      return "false"; 
    if (value.equalsIgnoreCase("yes") || value.equalsIgnoreCase("no"))
      return "no"; 
    if (value.equalsIgnoreCase("T") || value.equalsIgnoreCase("F"))
      return "F"; 
    if (value.equalsIgnoreCase("Y") || value.equalsIgnoreCase("N"))
      return "N"; 
    if (value.equalsIgnoreCase("是") || value.equalsIgnoreCase("否"))
      return "否"; 
    if (value.equalsIgnoreCase("1") || value.equalsIgnoreCase("0"))
      return "0"; 
    if (value.equalsIgnoreCase("01") || value.equalsIgnoreCase("00"))
      return "00"; 
    return "0";
  }
  
  public static boolean notNull(String value) {
    return (value != null && !value.equals(""));
  }
  
  public static boolean readBool(String str, int index) {
    boolean result = false;
    if (str != null && str.length() > index && index >= 0)
      result = (str.charAt(index) == '1'); 
    return result;
  }
  
  public static String writeBool(String str, int index, boolean value) {
    StringBuffer result = (str == null) ? new StringBuffer() : new StringBuffer(str);
    if (index >= 0) {
      int nullcount = index - result.length();
      for (int i = 0; i <= nullcount; i++)
        result.append('#'); 
      result.setCharAt(index, value ? 49 : 48);
    } 
    return result.toString();
  }
  
  public static String readString(String str, int beginIndex, int length) {
    String result = null;
    int endIndex = beginIndex + length;
    if (str != null && str.length() > beginIndex && beginIndex >= 0 && endIndex > beginIndex) {
      endIndex = (str.length() >= endIndex) ? endIndex : str.length();
      return str.substring(beginIndex, endIndex);
    } 
    return result;
  }
  
  public static String writeString(String str, int beginIndex, int length, String value) {
    StringBuffer result = (str == null) ? new StringBuffer() : new StringBuffer(str);
    if (beginIndex >= 0) {
      int nullcount = beginIndex + length - result.length();
      int i;
      for (i = 0; i < nullcount; i++)
        result.append(' '); 
      if (value != null)
        for (i = 0; i < length; i++) {
          char chr = (i < value.length()) ? value.charAt(i) : ' ';
          result.setCharAt(beginIndex + i, chr);
        }  
    } 
    return result.toString();
  }
  
  public static String[] StringToStrArray(String str, String split) {
    String[] result = (String[])null;
    if (isNull(str))
      return result; 
    if (isNull(split)) {
      result = new String[1];
      result[0] = str;
      return result;
    } 
    List<Object> list = new ArrayList();
    StringTokenizer st = new StringTokenizer(str, split);
    while (st.hasMoreElements())
      list.add(st.nextElement()); 
    if (list.size() > 0) {
      result = new String[list.size()];
      for (int i = 0; i < result.length; i++)
        result[i] = (String)list.get(i); 
    } else {
      result = new String[1];
      result[0] = str;
      return result;
    } 
    return result;
  }
  
  public static boolean equalStringArray(String str1, String str2) {
    boolean result = false;
    if (isNull(str1) && isNull(str2))
      return true; 
    String[] list1 = StringToStrArray(str1);
    String[] list2 = StringToStrArray(str2);
    if (list1 == null && list2 == null)
      return str1.equals(str2); 
    if (list1 == null || list2 == null)
      return str1.equals(str2); 
    if (list1.length != list2.length)
      return false; 
    for (int i = 0; i < list1.length; i++) {
      result = false;
      for (int k = 0; k < list2.length; k++) {
        if (list1[i].equals(list2[k])) {
          result = true;
          list2[k] = "_$#@_*&^#%^";
          break;
        } 
      } 
      if (!result)
        break; 
    } 
    return result;
  }
  
  public static String[] StringToStrArray(String str, char split) {
    String[] result = (String[])null;
    int p = 0;
    if (str == null || str.equals(""))
      return null; 
    if (str.indexOf(split) < 0) {
      result = new String[1];
      result[0] = str;
      return result;
    } 
    List<String> list = new ArrayList();
    int i;
    for (i = 0; i < str.length(); i++) {
      char c = str.charAt(i);
      if (c == split) {
        if (i - p > 0) {
          String s = str.substring(p, i);
          list.add(s);
        } else {
          list.add("");
        } 
        p = i + 1;
      } 
    } 
    if (p > 0 && p < str.length()) {
      String s = str.substring(p, str.length());
      list.add(s);
    } 
    if (list.size() > 0) {
      result = new String[list.size()];
      for (i = 0; i < list.size(); i++)
        result[i] = list.get(i); 
    } 
    return result;
  }
  
  public static String[] StringToStrArray(String str) {
    String[] result = (String[])null;
    int p = 0;
    if (str == null || str.equals(""))
      return null; 
    if (str.indexOf(';') < 0 && str.indexOf(',') < 0) {
      result = new String[1];
      result[0] = str;
      return result;
    } 
    List<String> list = new ArrayList();
    int i;
    for (i = 0; i < str.length(); i++) {
      char c = str.charAt(i);
      if (c == ';' || c == ',') {
        if (i - p > 0) {
          String s = str.substring(p, i);
          list.add(s);
        } else {
          list.add("");
        } 
        p = i + 1;
      } 
    } 
    if (p > 0 && p < str.length()) {
      String s = str.substring(p, str.length());
      list.add(s);
    } 
    if (list.size() > 0) {
      result = new String[list.size()];
      for (i = 0; i < list.size(); i++)
        result[i] = list.get(i); 
    } 
    return result;
  }
  
  public static String stringOfChar(char c, int length) {
    StringBuffer result = new StringBuffer(length);
    for (int i = 0; i < length; i++)
      result.append(c); 
    return result.toString();
  }
  
  public static String trimAll(String str, char c) {
    if (isNull(str))
      return null; 
    StringBuffer result = new StringBuffer(str.length());
    for (int i = 0; i < str.length(); i++) {
      if (str.charAt(i) != c)
        result.append(str.charAt(i)); 
    } 
    return result.toString();
  }
  
  public static String trimAll(String str) {
    return trimAll(str, ' ');
  }
  
  public static String trimL(String str) {
    if (isNull(str))
      return null; 
    if (str.length() == 0 || str.charAt(0) != ' ')
      return str; 
    int pos = 1;
    for (int i = pos; i < str.length(); ) {
      if (str.charAt(i) == ' ') {
        i++;
        continue;
      } 
      pos = i;
      break;
    } 
    return str.substring(pos);
  }
  
  public static String trimR(String str) {
    if (isNull(str))
      return null; 
    int len = str.length();
    if (len == 0 || str.charAt(len - 1) != ' ')
      return str; 
    int pos = len - 2;
    for (int i = pos; i >= 0; ) {
      if (str.charAt(i) == ' ') {
        i--;
        continue;
      } 
      pos = i;
      break;
    } 
    return str.substring(0, pos + 1);
  }
  
  public static String trimLR(String str) {
    if (isNull(str))
      return null; 
    return str.trim();
  }
  
  public static boolean safeEquals(String str1, String str2) {
    str1 = isNull(str1) ? "" : str1;
    str2 = isNull(str2) ? "" : str2;
    return str1.equals(str2);
  }
  
  public static boolean safeEqualsIgnoreCase(String str1, String str2) {
    str1 = isNull(str1) ? "" : str1;
    str2 = isNull(str2) ? "" : str2;
    return str1.equalsIgnoreCase(str2);
  }
  
  public static int safeCompare(String str1, String str2) {
    str1 = isNull(str1) ? "" : str1;
    str2 = isNull(str2) ? "" : str2;
    return str1.compareTo(str2);
  }
  
  public static int safeCompareIgnoreCase(String str1, String str2) {
    str1 = isNull(str1) ? "" : str1;
    str2 = isNull(str2) ? "" : str2;
    return str1.compareToIgnoreCase(str2);
  }
  
  public static int safeIndexOf(String str, String subStr) {
    str = isNull(str) ? "" : str;
    subStr = isNull(subStr) ? "" : subStr;
    return str.indexOf(subStr);
  }
  
  public static int safeIndexOfIgnoreCase(String str, String subStr) {
    str = isNull(str) ? "" : str.toLowerCase();
    subStr = isNull(subStr) ? "" : subStr.toLowerCase();
    return str.indexOf(subStr);
  }
}
